﻿package {	
	import flash.display.Sprite;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.filters.BlurFilter;
	import flash.geom.Point;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.geom.Rectangle;
	import flash.ui.Mouse;

	public class Particles1 extends Sprite{
		private var bmpData:BitmapData;
		private var filterObj:BlurFilter = new BlurFilter(20,20,2);
		private var particuleCollection:Array=[];
		private var couleursCollection:Array=[0xffffffff];
		private var myRect:Rectangle = new Rectangle(0,0,600,600);
		
		Mouse.hide();
		
		public function Particles1(){
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
			addEventListener(MouseEvent.MOUSE_MOVE, filler);
			addEventListener(MouseEvent.MOUSE_DOWN, erase);
		}
		private function addedHandler(e:Event):void{
			bmpData = new BitmapData(stage.stageWidth,stage.stageHeight,true,0);
			addChild(new Bitmap(bmpData)) as Bitmap;
			addEventListener(Event.ENTER_FRAME,boucle);
			
		}
		private function boucle(e:Event):void{
			for(var i:int=0;i<200;i++){
				var angle:int=Math.round(Math.random()*360);
				creationDeParticules(Math.cos(angle/180*Math.PI)*Math.random()*15,Math.sin(angle/180*Math.PI)*Math.random()*10,couleursCollection[Math.round(Math.random())],mouseX,mouseY);
			}
			var o:int = particuleCollection.length;
			//bmpData.applyFilter(bmpData,bmpData.rect,new Point(0,0),filterObj);
			bmpData.lock();
			while(o--) {
				var p:Object = particuleCollection[o];
				p.x+=p.vx;
				p.y+=p.vy;
				p.vx*=.6;
				p.vy*=.6;
				bmpData.setPixel32(p.x,p.y,p.c);
				if (p.vx+p.vy<0.2 && p.vx+p.vy>-0.2){particuleCollection.splice(o,1);}
			}
			bmpData.unlock();
		}
		private function creationDeParticules(vitesseX:Number, vitesseY:Number, couleur:uint, positionX:Number=0, positionY:Number=0):void {
			var particule:Object = {};
			particule.x = positionX;
			particule.y = positionY;
			particule.vx = vitesseX;
			particule.vy = vitesseY;
			particule.c = couleur;
			particuleCollection.push(particule);
		}
		private function erase(e:MouseEvent):void{
			//bmpData = new BitmapData(stage.stageWidth,stage.stageHeight,true,0xffffff);
			//this.graphics.beginFill(0x000000);
			//this.graphics.drawRect(0,0,stage.stageWidth,stage.stageHeight);
			//addChild(new Bitmap(bmpData)) as Bitmap;
			//this.graphics.beginFill(0xcccccc);
			//this.graphics.drawRect(0,0,stage.stageWidth,stage.stageHeight);
			bmpData.fillRect(myRect,0xffffff);
			bmpData.floodFill(0,0,0xffffff);
			//bmpData.floodFill(
			//trace(couleursCollection);
		}
		private function filler(e:MouseEvent):void{
			couleursCollection = [Math.random()*0xffffffff]

		}
	}
}